<?php if (!defined('IN_GS')) {die('you cannot load this page directly.');}

/*
 *	Plugin Name: Feedback
 *	Description: Feedback plugin for GetSimple
 *	Version: 0.1.1
 *	Thomas Klinski <thomas.klinski(at)ymail.com>
 * 
 *	This plugin is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */

function checkEnviroment() {
	if (@mkdir(GBDATAPATH, 0777)) {
		$fh = fopen(GBDATAPATH . '.htaccess', 'w');
		fwrite($fh, 'Deny from all');
		fclose($fh);
	}
	
	if (@mkdir(GBCONTENTPATH, 0777)) {
		$fh = fopen(GBCONTENTPATH . '.htaccess', 'w');
		fwrite($fh, 'Deny from all');
		fclose($fh);
	}
	
	if (!file_exists(GBSETTINGS)) {
		$xml = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><settings />');
		// $xml->addChild('language', 'de');
		// $xml->addChild('entries_per_page', 10);
		// $xml->addChild('embedded_mode', 1);
		
		$message = $xml->addChild('message');
		$message->addAttribute('min', 50);
		$message->addAttribute('max', 1023);
		
		$firstname = $xml->addChild('firstname');
		$firstname->addAttribute('min', 0);
		$firstname->addAttribute('max', 31);
		
		$lastname = $xml->addChild('lastname');
		$lastname->addAttribute('min', 1);
		$lastname->addAttribute('max', 31);
		
		$location = $xml->addChild('location');
		$location->addAttribute('min', 1);
		$location->addAttribute('max', 31);
		
		$email = $xml->addChild('email');
		$email->addAttribute('min', 0);
		$email->addAttribute('max', 31);
		
		$homepage = $xml->addChild('homepage');
		$homepage->addAttribute('min', 0);
		$homepage->addAttribute('max', 31);
		
		@XMLsave($xml, GBSETTINGS);
 	}
}
 
function prepareValue($val, $len = 0) {
	$old_val = $val;
	$val = antixss($val);
	if ($old_val != $val) {
		debugLog(date('H:i:s') . " xss found [" . htmlentities($old_val) . ", " . $_SERVER['REMOTE_ADDR'] . "]");	
	}	
	$val = stripslashes($val);
	$val = htmlentities($val, ENT_NOQUOTES, 'UTF-8');
	return trim($val);
} 
 
/**
 *	@function newEntry
 *	@param $title of submitter
 *	@param $name of submitter
 *	@param $location of submitter
 *	@param $email of submitter
 *	@param $homepage of submitter
 *	@param $message antixss()
 */ 
 
function newEntry($title, $firstname, $name, $location, $email, $homepage, $message) {
	$id = md5(uniqid(mt_rand(), true));
	$createDate = date("d.m.Y H:i");
	$time = time();
	$ip = $_SERVER['REMOTE_ADDR'];
	
	$xml = new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><entry />');
	$xml->addAttribute('id', $id);
	$xml->addAttribute('date', $createDate);
	$xml->addAttribute('hide', 0);
	$newTitle = $xml->addChild('title', $title);
	$newFirstname = $xml->addChild('firstname');
	$newFirstname->addCData($firstname);
	$newName = $xml->addChild('name');
	$newName->addCData($name);
	$newLocation = $xml->addChild('location');
	$newLocation->addCData($location);
	$newName = $xml->addChild('email', $email);
	$newHomepage = $xml->addChild('homepage', $homepage);
	$newText = 	$xml->addChild('message');
	$newText->addCData($message);
	$newIp = $xml->addChild('ip', $ip);
	
	@XMLsave($xml, GBCONTENTPATH . $id . '.xml');
}

function editEntry($id, $title, $firstname, $name, $location, $email, $homepage, $message) {
	$xml = @getXML(GBCONTENTPATH . $id . '.xml');
	$xml->title = $title;
	$xml->firstname = $firstname;
	$xml->name = $name;
	$xml->location = $location;
	$xml->email = $email;
	$xml->homepage = $homepage;
	$xml->message = safe_slash_html($message);
	@XMLsave($xml, GBCONTENTPATH . $id . '.xml');
}

function saveOptions($firstname, $lastname, $location, $email, $homepage, $message) {
	$settings = @getXML(GBSETTINGS);
	
	$settings->firstname['min'] = (int) $firstname['min'];
	$settings->firstname['max'] = (int) $firstname['max'];
	$settings->lastname['min'] 	= (int) $lastname['min'];
	$settings->lastname['max'] 	= (int) $lastname['max'];
	$settings->location['min'] 	= (int) $location['min'];
	$settings->location['max'] 	= (int) $location['max'];
	$settings->email['min'] 	= (int) $email['min'];
	$settings->email['max'] 	= (int) $email['max'];
	$settings->homepage['min'] 	= (int) $homepage['min'];
	$settings->homepage['max'] 	= (int) $homepage['max'];
	$settings->message['min'] 	= (int) $message['min'];
	$settings->message['max'] 	= (int) $message['max'];
	
	@XMLsave($settings, GBSETTINGS);
}

function releaseEntry($id, $val) {
	$xml = @getXML(GBCONTENTPATH . $id . '.xml');
	$xml['hide'] = $val;
	@XMLsave($xml, GBCONTENTPATH . $id . '.xml');
}

function deleteEntry($id) {
	unlink(GBCONTENTPATH . $id . '.xml');
}

function getAllEntries() {
	$count = 0;	
	ob_start();
	$entries = @getFiles(GBCONTENTPATH);
	
	echo '<div class="feedback-wrapper">';
	foreach ($entries as $file) {
		if (isFile($file, GBCONTENTPATH, 'xml')) {
			$id = basename($file, '.xml');
			$entry = @getXML(GBCONTENTPATH . $id . '.xml');
			if($entry['hide'] == 1) {
				include(GBTEMPLATEPATH . 'entry.php');
			}
			$count++;
		}
	} 
	echo '</div>';
	
	if ($count == 0) {
		echo '<div class="inline-warning">'. i18n_r('feedback/INFO_NOT_FOUND') .'</div>';
	}

	$content = ob_get_contents();
	ob_end_clean();
	return $content;
}

function getSubmitFormular() {
	global $settings;
	ob_start();
	include(GBTEMPLATEPATH . 'add_entry.php');
	$content = ob_get_contents();
	ob_end_clean();
	return $content;
}
 
/**
 * @function getLanguages
 * @return array with all accessible languages
 */
function getLanguages() {
	$langs = array();
	$files = getFiles(GBLANGPATH);
	foreach ($files as $file) {
		if (isFile($file, GBLANGPATH, 'php')) {
			$lang = basename($file, '.php');
			$langs[$lang] = GBLANGPATH . $file;
		}
	}
	ksort($langs);
	return $langs;
}

function getRandomEntry() {
	$titles = explode (',', i18n_r('feedback/TITLE_LIST'));
	$entriesArray = array();
	$entries = getFiles(GBCONTENTPATH);
	$count = 0;
	
	foreach ($entries as $file) {
		if (isFile($file, GBCONTENTPATH, 'xml')) {
			$id = basename($file, '.xml');
			$entry = @getXML(GBCONTENTPATH . $id . '.xml');
			if($entry['hide'] == 1) {
				$entriesArray[$count]['id'] = $id;
				$entriesArray[$count]['date'] = $entry['date'];
				$entriesArray[$count]['title'] = $titles[(string)$entry->title];
				$entriesArray[$count]['name'] = $entry->name;
				$entriesArray[$count]['location'] = $entry->location;
				$entriesArray[$count]['message'] = $entry->message;
				
				$count++;
			}
		}
	}
	
	return $entriesArray[array_rand($entriesArray)];
}

?>
